setInfos(6, "Baccarat-chemin-de-fer", "Play chemin de fer against the bank.","NIFOC99", 
"v0.2", 0x1E8449, "en", ["game"])

show(null)
setImage("Baccarat/i001.jpg")
def Title = "<h1 style='font-size:140%;'>Baccarat</h1>\n\n"
def Version = "v0.2"
//send("Baccarat.Version", Version)//only for new versions
/*show(Title+"Checking version")
if(isConnected()&&receiveString("Baccarat.Version")!=Version) {
	show(Title+"This ("+Version+") is not the latest version ("+receiveString("Baccarat.Version")+").")
	wait(0.5)
	show(Title+"Check for the latest version at ss.deviatenow.com/scripts.php")
	wait(2)
	showButton("OK")
}*/
show(null)

def Deck = []
def Card = 0
def Np = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
def Nt = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
def Ptireur = [1.0, 1.0, 1.0, 1.0, 1.0, 0.5, 0.0, 0.0, 0.0, 0.0]
def Discards = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
def Q = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
def R = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

//settings
def NoDecks = loadInteger("Baccarat.NoDecks")?: 6
def DeckName = loadString("Baccarat.DeckName")?: "StandardDeck1"
def ObeyRules = loadBoolean("Baccarat.ObeyRules")?: true

//Closures (functions)######################################################################

def ShowRules = {//basic settings-----------------------------------------------------------
	setImage(null)
	show(Title+"Valuation of hands\n\nIn baccarat, cards have a point value:"+
		"<table><tr><td>ace</td><td>1</td></tr>"+
		"<tr><td>2 to 9</td><td>2 - 9</td></tr>"+
		"<tr><td>10, court/face</td><td>0</td></tr></table>"+
		"Hands are valued according to units digit of the sum of their constituent cards. "+
		"For example, a hand consisting of 2 and 3 is worth 5, but a hand consisting of "+
		"6 and 7 is worth 3, not of 13. The highest possible hand value in baccarat is "+
		"therefore nine.")
	showButton("next")
	show(Title+"Chemin de fer\n\nThis is a version of baccarat which first appeared in the "+
		"late 19th century. By default, six decks of cards are used, shuffled together.\n"+
		"In physical chemin de fer, the bank may move anticlockwise round the table during the game, and "+
		"and the player plays for other players at the table. In this script, you always "+
		"play solo against the bank.\n"+
		"Two hands of two cards are dealt. If either has an eight or a nine, this is "+
		"a <em>natural</em> and is immediately announced and the hands are turned face-up "+
		"and compared. If there is no <em>natural</em>, the player may accept a third card, "+
		"dealt face-up. There are <em>player rules</em> (<em>tableau</em>) that dictate "+
		"whether the player "+
		"accepts a card (<em>carte</em>) or not. If there is a thrid card, it is dealt "+
		"face-up. Based in their hand and the pleyers third card, the banker, in turn, "+
		"decides either to accept or to refuse another card.")
	showButton("next")
	show(Title+"Players rules\n\nThe rules say that the player always accepts a card "+
		"(<em>carte</em>) if their hand is less than 5. If their hand is greater than 5, "+
		"they refuse a card. If the total is 5, the player is free to choose whether they "+
		"take a card. These rules are basec on the best probability of winning, and are "+
		"always adhered to in physical games. In this script, you have the option to break "+
		"these rules. This may confuse the banker, but is not a great option for getting "+
		"the best score.")
	showButton("OK")
}

def Settings = {//basic settings------------------------------------------------------------
	NoDecks = getInteger(Title+"Chemin de fer is usually played with six decks", 6)
	save("Baccarat.NoDecks", NoDecks)
	ObeyRules = getBoolean(Title+"Do you want to obey the palyer rules stricktly?\n"+
		"(This gives you the best chance of winning)", "Yes", "No")
	save("Baccarat.ObeyRules", ObeyRules)
}

def ChooseDeck = {//------------------------------------------------------------------------
	def DeckNames = []
	setImage("Bcards/"+DeckName+"/"+getRandom(52)+".png")
	if(getBoolean(Title+"Current deck is "+DeckName, "select new deck", "cancel")){		
		new File(getDataFolder().replaceAll("\\\\", "/")+"images/Bcards/").eachFile() {file->
			if(file.isDirectory()) {DeckNames << file.getName()}
		}
		def i=0
		while(i<DeckNames.size){
			setImage("Bcards/"+DeckNames[i]+"/"+getRandom(52)+".png")
			if(getBoolean(Title+DeckNames[i], "select deck", "next ->")){
				DeckName = DeckNames[i]
				save("Baccarat.DeckName", DeckName)
				i = DeckNames.size
			}else{
				i++
				if(i==DeckNames.size)i = 0
			}
		}
	}
	setImage(null)
}

def Shoe = {//set up shoe-------------------------------------------------------------------
	for(def i=0; i<NoDecks; i++){
		for(def j=0; j<52; j++){
			Deck[i*52+j] = j
		}
	}
	Collections.shuffle(Deck)
	Card = 0
}

//Display card images
def showCards= { cards -> //----------------------------------------------------------------
	def width = 540
	def height = 500
	def image = new java.awt.image.BufferedImage(width, height, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
	def graphics = image.getGraphics()
	def sampleImage = java.awt.Toolkit.getDefaultToolkit().getImage(
		"images/Bcards/"+DeckName+"/0.png")
	def oneWidth = sampleImage.getWidth()
	def oneHeight = sampleImage.getHeight()
	for(def i = 0;i<cards.size;i++)
		for(def j = 0;j<cards[i].size;j++) {
			def x = j * (width - oneWidth) / 2
			if(j==1) x = x-oneWidth/3
			def delta = (i*j + i * 5 + j * 7) % 4
			def y = i * (height - oneHeight - 3) + delta +j
			def thisImage 
			if(cards[i][j]<52){
				thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/"+cards[i][j]+".png"))
			} else {
				thisImage = javax.imageio.ImageIO.read(new File("images/Bcards/"+DeckName+"/back.png"))
			}
			if(i==0) {
				graphics.rotate(Math.PI, width/2, (oneHeight + 3)/2)
			}
			graphics.drawImage(thisImage, (int)x, (int)y, null)
			if(i==0) {
				graphics.rotate(-Math.PI, width/2, (oneHeight + 3)/2)
			}
		}
	java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
	javax.imageio.ImageIO.write(image, "png", baos)
	setImage(baos.toByteArray(),0)
}

def getScore = { card -> //-----------------------------------------------------------------
	def s
	if(card<52) s = (int)Math.ceil((card+1)/4)
	else s = (int)Math.ceil((card-51)/4)
	if(s>9)s=0
	return s
}

def getFullScore = {cards -> //--------------------------------------------------------------
	def res = 0
	for(def c : cards){res += getScore(c)}
	return (int)res%10
}

def Tireur = {cards -> //--------------------------------------------------------------
	def S1 = (int)(getScore(cards[1][0])+getScore(cards[1][1]))%10
	Np[S1]++
	if(cards[1][2]!=null)Nt[S1]++
	if(Np[S1]>2&&cards[1][2]!=null)Ptireur[S1] = Nt[S1]/Np[S1]
//;	getBoolean(Ptireur);	getBoolean(Nt);	getBoolean(Np)
}

def P = {C1, C2 -> //prob cards C1 and C2------------------------------------------------=====
	def pp = 0.0
	if(C1==0){
		pp = (NoDecks*16-Discards[C1])/(NoDecks*52-Card+2)
	}else{
		pp = (NoDecks*4-Discards[C1])/(NoDecks*52-Card+2)	
	}
	if(C1==C2){
		if(C2==0){
			pp = pp*(NoDecks*16-Discards[C2]-1)/(NoDecks*52-Card+1)
		}else{
			pp = pp*(NoDecks*4-Discards[C2]-1)/(NoDecks*52-Card+1)	
		}
	}else{
		if(C2==0){
			pp = pp*(NoDecks*16-Discards[C2])/(NoDecks*52-Card+1)
		}else{
			pp = pp*(NoDecks*4-Discards[C2])/(NoDecks*52-Card+1)	
		}
	}
}

def Pplayer0 = { //does not take a card-----------------------------------------------------
	Q[0] = (1-Ptireur[0])*(P(0, 0)+P(1, 9)+P(2, 8)+P(3, 7)+P(4, 6)+P(5, 5)+P(6, 4)+P(7, 3)+P(8, 2)+P(9, 1))
	Q[1] = (1-Ptireur[1])*(P(0, 1)+P(1, 0)+P(2, 9)+P(3, 8)+P(4, 7)+P(5, 6)+P(6, 5)+P(7, 4)+P(8, 3)+P(9, 2))
	Q[2] = (1-Ptireur[2])*(P(0, 2)+P(1, 1)+P(2, 0)+P(3, 9)+P(4, 8)+P(5, 7)+P(6, 6)+P(7, 5)+P(8, 4)+P(9, 3))
	Q[3] = (1-Ptireur[3])*(P(0, 3)+P(1, 2)+P(2, 1)+P(3, 0)+P(4, 9)+P(5, 8)+P(6, 7)+P(7, 6)+P(8, 5)+P(9, 4))
	Q[4] = (1-Ptireur[4])*(P(0, 4)+P(1, 3)+P(2, 2)+P(3, 1)+P(4, 0)+P(5, 9)+P(6, 8)+P(7, 7)+P(8, 6)+P(9, 5))
	Q[5] = (1-Ptireur[5])*(P(0, 5)+P(1, 4)+P(2, 3)+P(3, 2)+P(4, 1)+P(5, 0)+P(6, 9)+P(7, 8)+P(8, 7)+P(9, 6))
	Q[6] = (1-Ptireur[6])*(P(0, 6)+P(1, 5)+P(2, 4)+P(3, 3)+P(4, 2)+P(5, 1)+P(6, 0)+P(7, 9)+P(8, 8)+P(9, 7))
	Q[7] = (1-Ptireur[7])*(P(0, 7)+P(1, 6)+P(2, 5)+P(3, 4)+P(4, 3)+P(5, 2)+P(6, 1)+P(7, 0)+P(8, 9)+P(9, 8))
	Q[8] = (1-Ptireur[8])*(P(0, 8)+P(1, 7)+P(2, 6)+P(3, 5)+P(4, 4)+P(5, 3)+P(6, 2)+P(7, 1)+P(8, 0)+P(9, 9))
	Q[9] = (1-Ptireur[9])*(P(0, 9)+P(1, 8)+P(2, 7)+P(3, 6)+P(4, 5)+P(5, 4)+P(6, 3)+P(7, 2)+P(8, 1)+P(9, 0))
}

def Pplayer1 = { Cp -> //takes a card-------------------------------------------------------
	Q[(0+Cp)%10] = Ptireur[0]*(P(0, 0)+P(1, 9)+P(2, 8)+P(3, 7)+P(4, 6)+P(5, 5)+P(6, 4)+P(7, 3)+P(8, 2)+P(9, 1))
	Q[(1+Cp)%10] = Ptireur[1]*(P(0, 1)+P(1, 0)+P(2, 9)+P(3, 8)+P(4, 7)+P(5, 6)+P(6, 5)+P(7, 4)+P(8, 3)+P(9, 2))
	Q[(2+Cp)%10] = Ptireur[2]*(P(0, 2)+P(1, 1)+P(2, 0)+P(3, 9)+P(4, 8)+P(5, 7)+P(6, 6)+P(7, 5)+P(8, 4)+P(9, 3))
	Q[(3+Cp)%10] = Ptireur[3]*(P(0, 3)+P(1, 2)+P(2, 1)+P(3, 0)+P(4, 9)+P(5, 8)+P(6, 7)+P(7, 6)+P(8, 5)+P(9, 4))
	Q[(4+Cp)%10] = Ptireur[4]*(P(0, 4)+P(1, 3)+P(2, 2)+P(3, 1)+P(4, 0)+P(5, 9)+P(6, 8)+P(7, 7)+P(8, 6)+P(9, 5))
	Q[(5+Cp)%10] = Ptireur[5]*(P(0, 5)+P(1, 4)+P(2, 3)+P(3, 2)+P(4, 1)+P(5, 0)+P(6, 9)+P(7, 8)+P(8, 7)+P(9, 6))
	Q[(6+Cp)%10] = Ptireur[6]*(P(0, 6)+P(1, 5)+P(2, 4)+P(3, 3)+P(4, 2)+P(5, 1)+P(6, 0)+P(7, 9)+P(8, 8)+P(9, 7))
	Q[(7+Cp)%10] = Ptireur[7]*(P(0, 7)+P(1, 6)+P(2, 5)+P(3, 4)+P(4, 3)+P(5, 2)+P(6, 1)+P(7, 0)+P(8, 9)+P(9, 8))
	Q[(8+Cp)%10] = Ptireur[8]*(P(0, 8)+P(1, 7)+P(2, 6)+P(3, 5)+P(4, 4)+P(5, 3)+P(6, 2)+P(7, 1)+P(8, 0)+P(9, 9))
	Q[(9+Cp)%10] = Ptireur[9]*(P(0, 9)+P(1, 8)+P(2, 7)+P(3, 6)+P(4, 5)+P(5, 4)+P(6, 3)+P(7, 2)+P(8, 1)+P(9, 0))
}

def Pbank0 = { cards -> //prob bank win without taking card-------------------------------------
	def S1 = getFullScore(cards[0])
	float pp = 0.0
	if(cards[1][2]==null){Pplayer0()}
	else{Pplayer1(getScore(cards[1][2]))}
	for(def i=S1; i>=0; i--){pp = pp+Q[i]}
	return pp
}

def Pbank1 = { cards -> //prob bank win after taking card---------------------------------------
	def S1 = getFullScore(cards[0])
	float pp = 0.0
	if(cards[1][2]==null){Pplayer0()}
	else{Pplayer1(getScore(cards[1][2]))}
	for(def i=0; i<10; i++){
		if(i==0){
			R[(S1+i)%10] = (NoDecks*16-Discards[i])/(NoDecks*52-Card+2)
		}else{
			R[(S1+i)%10] = (NoDecks*4-Discards[i])/(NoDecks*52-Card+2)	
		}
	}
	for(def i=0; i<10; i++){
		for(def j=i; j>=0; j--){pp = pp+R[j]*Q[j]}
	}
	return pp
}

def CoupChemindefer = {//play chemin de fer-------------------------------------------------
	def cards = [[],[]]
	def PlayerScore = 0
//deal
	cards[1].add(Deck[Card]+52)
	showCards(cards)
	wait(1)
	Card++
	cards[0].add(Deck[Card]+52)
	showCards(cards)
	wait(1)
	Card++
	cards[1].add(Deck[Card]+52)
	showCards(cards)
	wait(1)
	Card++
	cards[0].add(Deck[Card]+52)
	showCards(cards)
	wait(3)
//look at cards
	cards[1][0]=cards[1][0]-52
	cards[1][1]=cards[1][1]-52
	showCards(cards)
	wait(0.5)
//play
	if(getFullScore(cards[1])>7||getFullScore(cards[0])>7){//natural
		if(getFullScore(cards[1])>7){
			show(Title+"You have a natural")
			showButton("natural")//player natural
		}else{
			show(Title+"Bank has natural")
			wait(1)
		}
		//show bank cards
		cards[0][0]=cards[0][0]-52
		cards[0][1]=cards[0][1]-52
		showCards(cards)
		show(Title+"Bank hand: "+getFullScore(cards[0])+"\n"+
			"Your hand: "+getFullScore(cards[1]))
		Discards[getScore(cards[0][0])]++
		Discards[getScore(cards[0][1])]++
		Discards[getScore(cards[1][0])]++
		Discards[getScore(cards[1][1])]++
	}
	else {// not natural
		if(ObeyRules){
			if(getFullScore(cards[1])<5){//carte
				show(Title+"Your hand: "+getFullScore(cards[1])+"\n"+"Take a card")
				showButton("carte")
				Card++
				cards[1].add(Deck[Card])
				showCards(cards)
				show(Title+"Your hand: "+getFullScore(cards[1])+"\nBank sees your third card")
			}else if(getFullScore(cards[1])>5){//stand
				show(Title+"Your hand: "+getFullScore(cards[1])+"\n"+
					"You stand")
				showButton("stand")
				show(Title+"Your hand: "+getFullScore(cards[1]))
			}else{//carte or stand
				if(getBoolean(Title+"Your hand: "+getFullScore(cards[1]), "carte", "stand")){
					Card++
					cards[1].add(Deck[Card])
					showCards(cards)
					show(Title+"Your hand: "+getFullScore(cards[1])+"\nBank sees your third card")
				}
			}
		}else{
			if(getBoolean(Title+"Your hand: "+getFullScore(cards[1]), "carte", "stand")){
				Card++
				cards[1].add(Deck[Card])
				showCards(cards)
				show(Title+"Your hand: "+getFullScore(cards[1])+"\nBank sees your third card")
			}
		}
		if(cards[1][2]!=null){Discards[getScore(cards[1][2])]++}
		Discards[getScore(cards[0][0])]++
		Discards[getScore(cards[0][1])]++
//banker prob of winning
		if(Pbank0(cards)<Pbank1(cards)){
			wait(1)
			Card++
			cards[0].add(Deck[Card])
			showCards(cards)
			show(Title+"Bank takes a card")
			Discards[getScore(cards[0][2])]++
		}
		wait(2)
//show cards
		cards[0][0]=cards[0][0]-52
		cards[0][1]=cards[0][1]-52
		showCards(cards)
		show(Title+"Bank hand: "+getFullScore(cards[0])+"\n"+
			"Your hand: "+getFullScore(cards[1]))
		Discards[getScore(cards[1][0])]++
		Discards[getScore(cards[1][1])]++
//Tireur data
		Tireur(cards)
	}
//who won?
	wait(3)
	if(getFullScore(cards[0])<getFullScore(cards[1])){
		show(Title+"Player win")
		wait(3)
		return 1
	}else if(getFullScore(cards[0])>getFullScore(cards[1])){
		show(Title+"Bank win")
		wait(3)
		return 0
	}else{
		show(Title+"Égalité - bank win")
		wait(3)
		return 0
	}
}	

//Start#####################################################################################

def EndGame = false
while(!EndGame){
	switch(getSelectedValue(Title+"This is a game of chemin de fer, just you against the "+
		"bank. To give me an unfair advantage, the bank wins if the scores are tied.", 
		["play", "rules", "settings", "end"])){
	case 0://play
//shuffle
		Shoe()
//play
		Np = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
		Nt = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
		Ptireur = [1.0, 1.0, 1.0, 1.0, 1.0, 0.5, 0.0, 0.0, 0.0, 0.0]
		Discards = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
		Q = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
		R = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
		def Play = true
		def BankScore = 0
		def PlayerScore = 0
		while(Play){
// play
			show(null)
			if(CoupChemindefer()==0){//bank win
				BankScore++
			}else{//player win
				PlayerScore++
			}
			if(Card>NoDecks*52-7){
				Play=false
				show(Title+"End of cards")
				showButton("OK")
			}else{
				Play = getBoolean(Title+"Bank score: "+BankScore+"\nPlayer score: "+PlayerScore, 
					"play again", "end")
			}
		}
		break
	case 1://rules
		ShowRules()
		break
	case 2:
		ChooseDeck()
		Settings()
		break
	case 3:
		setImage(null)
		show(null)
		EndGame = true
		wait(2)
	}
}
// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
/*
 * Resources
 * scripts/Baccarat-chemin-de-fer.groovy
 * images/Baccarat/i*.jpg
 * images/Baccarat/i*.png
 * images/Bcards/StandardDeck1/*.png
 */
